Index: code/trunk/src/util/CRC32.cc
===================================================================
--- code/trunk/src/util/CRC32.cc	(revision 1784)
+++ code/trunk/src/util/CRC32.cc	(revision 1791)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      ...
  *   Co-authors:
  *      ...
@@ -32,5 +32,5 @@
 void calcCRCBit(uint32_t &crc32, int bit){
     int hbit;
- 
+
     hbit=(crc32 & 0x80000000) ? 1 : 0;
     if (hbit != bit)
Index: code/trunk/src/util/CRC32.h
===================================================================
--- code/trunk/src/util/CRC32.h	(revision 1784)
+++ code/trunk/src/util/CRC32.h	(revision 1791)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      ...
  *   Co-authors:
  *      ...
Index: code/trunk/src/util/Clipboard.cc
===================================================================
--- code/trunk/src/util/Clipboard.cc	(revision 1784)
+++ code/trunk/src/util/Clipboard.cc	(revision 1791)
@@ -29,10 +29,24 @@
  */
 
+/**
+    @file Clipboard.cc
+    @brief OS-specific implementations of the clipboard functions.
+*/
+
 #include "Clipboard.h"
 
 #if ORXONOX_PLATFORM == ORXONOX_PLATFORM_WIN32
+    /////////////
+    // Windows //
+    /////////////
     #include <windows.h>
+    #include "Debug.h"
 
-    bool toClipboard(std::string text)
+    /**
+        @brief Puts text into the windows-clipboard
+        @param text The text
+        @return True if the action was successful
+    */
+    bool toClipboard(const std::string& text)
     {
         try
@@ -53,8 +67,14 @@
         catch (...)
         {
+            COUT(1) << "Error: Unable to copy the following text to the clipboard:" << std::endl;
+            COUT(1) << "       \"" << text << "\"" << std::endl;
         }
         return false;
     }
 
+    /**
+        @brief Gets text from the windows-clipboard if there is any text.
+        @return The retrieved text
+    */
     std::string fromClipboard()
     {
@@ -73,11 +93,21 @@
         catch (...)
         {
+            COUT(1) << "Error: Unable to retrieve text from the clipboard." << std::endl;
         }
         return "";
     }
 #else
-    std::string clipboard = "";
+    /////////////
+    // Default //
+    /////////////
 
-    bool toClipboard(std::string text)
+    std::string clipboard = ""; //!< Keeps the text of our internal clipboard
+
+    /**
+        @brief Default implementation if there is no OS-specific implementation or no clipboard. Copies the text into an internal clipboard.
+        @param text The text
+        @return True
+    */
+    bool toClipboard(const std::string& text)
     {
         clipboard = text;
@@ -85,4 +115,8 @@
     }
 
+    /**
+        @brief Default implementation if there is no OS-specific implementation or no clipboard. Gets the text from the internal clipboard.
+        @return The text
+    */
     std::string fromClipboard()
     {
Index: code/trunk/src/util/Clipboard.h
===================================================================
--- code/trunk/src/util/Clipboard.h	(revision 1784)
+++ code/trunk/src/util/Clipboard.h	(revision 1791)
@@ -27,4 +27,16 @@
  */
 
+/**
+    @file Clipboard.h
+    @brief Some functions to exchange text between the OS clipboard and Orxonox.
+
+    Use fromClipboard() to get text from the clipboard (if there is any text) and
+    toClipboard(text) to put text into the clipboard.
+
+    Those functions can only work properly if there's an OS-specific implementation.
+    If an OS isn't supported, the clipboard only works within Orxonox, but exchange
+    with other programs isn't possible.
+*/
+
 #ifndef _Clipboard_H__
 #define _Clipboard_H__
@@ -35,5 +47,5 @@
 
 
-_UtilExport bool toClipboard(std::string text);
+_UtilExport bool toClipboard(const std::string& text);
 _UtilExport std::string fromClipboard();
 
Index: code/trunk/src/util/Debug.h
===================================================================
--- code/trunk/src/util/Debug.h	(revision 1784)
+++ code/trunk/src/util/Debug.h	(revision 1791)
@@ -28,8 +28,32 @@
 
 /**
- * @file Debug.h
- * @brief Handles the output for different verbose-modes.
- *
- * There are two modes: HARD and SOFT. HARD is precessed during compiletime, while SOFT is for runtime.
+    @file Debug.h
+    @brief Handles different output-levels of errors, warnings, infos and debug informations.
+
+    The COUT(level) macro acts like std::cout, but the output is only performed if the given
+    level is <= the soft debug level.
+
+    There are two used values in this file:
+     - The hard debug level is used during compiletime. It describes the highest allowed output level.
+     - The soft debug level is used during runtime and is the maximum of the three configurable
+       output-levels for console, logfile and ingame shell.
+
+    The separation between the three devices is done by the OutputHandler.
+
+    Possible levels are:
+     0: Very important output
+     1: Errors
+     2: Warnings
+     3: Informations
+     4: Debug information
+     5: More debug information
+     6: Crazy debug informations
+
+    @example
+    COUT(0) << "Very important output" << std::endl;
+    COUT(1) << "Error: Something went wrong!" << std::endl;
+    COUT(2) << "Warning: There might be a problem." << std::endl;
+    COUT(3) << "Info: It's monday" << std::endl;
+    COUT(4) << "Debug: x is 1.23456" << std::endl;
  */
 
Index: code/trunk/src/util/Math.cc
===================================================================
--- code/trunk/src/util/Math.cc	(revision 1784)
+++ code/trunk/src/util/Math.cc	(revision 1791)
@@ -27,4 +27,9 @@
  */
 
+/**
+    @file Math.cc
+    @brief Implementation of several math-functions.
+*/
+
 #include <OgrePlane.h>
 
@@ -33,5 +38,5 @@
 
 /**
-    @brief Function for writing to a stream.
+    @brief Function for writing a Radian to a stream.
 */
 std::ostream& operator<<(std::ostream& out, const orxonox::Radian& radian)
@@ -42,5 +47,5 @@
 
 /**
-    @brief Function for reading from a stream.
+    @brief Function for reading a Radian from a stream.
 */
 std::istream& operator>>(std::istream& in, orxonox::Radian& radian)
@@ -53,5 +58,5 @@
 
 /**
-    @brief Function for writing to a stream.
+    @brief Function for writing a Degree to a stream.
 */
 std::ostream& operator<<(std::ostream& out, const orxonox::Degree& degree)
@@ -62,5 +67,5 @@
 
 /**
-    @brief Function for reading from a stream.
+    @brief Function for reading a Degree from a stream.
 */
 std::istream& operator>>(std::istream& in, orxonox::Degree& degree)
@@ -73,4 +78,16 @@
 
 
+/**
+    @brief Gets the angle between my viewing direction and the direction to the position of the other object.
+    @param myposition My position
+    @param mydirection My viewing direction
+    @param otherposition The position of the other object
+    @return The angle
+
+    @example
+    If the other object is exactly in front of me, the function returns 0.
+    If the other object is exactly behind me, the function returns pi.
+    If the other object is exactly right/left to me (or above/below), the function returns pi/2.
+*/
 float getAngle(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& otherposition)
 {
@@ -83,4 +100,19 @@
 }
 
+/**
+    @brief Gets the 2D viewing direction (up/down, left/right) to the position of the other object.
+    @param myposition My position
+    @param mydirection My viewing direction
+    @param myorthonormal My orthonormalvector (pointing upwards through my head)
+    @param otherposition The position of the other object
+    @return The viewing direction
+
+    @example
+    If the other object is exactly in front of me, the function returns Vector2(0, 0).
+    If the other object is exactly at my left, the function returns Vector2(-1, 0).
+    If the other object is exactly at my right, the function returns Vector2(1, 0).
+    If the other object is only a bit at my right, the function still returns Vector2(1, 0).
+    If the other object is exactly above me, the function returns Vector2(0, 1).
+*/
 orxonox::Vector2 get2DViewdirection(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition)
 {
@@ -100,4 +132,19 @@
 }
 
+/**
+    @brief Gets the 2D viewing direction (up/down, left/right) to the position of the other object, multiplied with the viewing distance to the object (0° = 0, 180° = 1).
+    @param myposition My position
+    @param mydirection My viewing direction
+    @param myorthonormal My orthonormalvector (pointing upwards through my head)
+    @param otherposition The position of the other object
+    @return The viewing direction
+
+    @example
+    If the other object is exactly in front of me, the function returns Vector2(0, 0).
+    If the other object is exactly at my left, the function returns Vector2(-0.5, 0).
+    If the other object is exactly at my right, the function returns Vector2(0.5, 0).
+    If the other object is only a bit at my right, the function still returns Vector2(0.01, 0).
+    If the other object is exactly above me, the function returns Vector2(0, 0.5).
+*/
 orxonox::Vector2 get2DViewcoordinates(const orxonox::Vector3& myposition, const orxonox::Vector3& mydirection, const orxonox::Vector3& myorthonormal, const orxonox::Vector3& otherposition)
 {
@@ -121,4 +168,14 @@
 }
 
+/**
+    @brief Returns the predicted position I have to aim at, if I want to hit a moving target with a moving projectile.
+    @param myposition My position
+    @param projectilespeed The speed of my projectile
+    @param targetposition The position of my target
+    @param targetvelocity The velocity of my target
+    @return The predicted position
+
+    The function predicts the position based on a linear velocity of the target. If the target changes speed or direction, the projectile will miss.
+*/
 orxonox::Vector3 getPredictedPosition(const orxonox::Vector3& myposition, float projectilespeed, const orxonox::Vector3& targetposition, const orxonox::Vector3& targetvelocity)
 {
Index: code/trunk/src/util/Math.h
===================================================================
--- code/trunk/src/util/Math.h	(revision 1784)
+++ code/trunk/src/util/Math.h	(revision 1791)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file Math.h
+    @brief Declaration and implementation of several math-functions, typedefs of some Ogre::Math classes to the orxonox namespace.
+*/
 
 #ifndef _Util_Math_H__
@@ -68,5 +73,5 @@
 
 //Get around Windows hackery
-#if ORXONOX_PLATFORM == ORXONOX_PLATFORM_WIN32 
+#if ORXONOX_PLATFORM == ORXONOX_PLATFORM_WIN32
 #  ifdef max
 #    undef max
@@ -77,4 +82,9 @@
 #endif
 
+/**
+    @brief Returns the sign of the given value.
+    @param x The value
+    @return 1 if the value is positive or zero, -1 if the value is negative
+*/
 template <typename T>
 inline T sgn(T x)
@@ -83,4 +93,7 @@
 }
 
+/**
+    @brief Returns the smaller of two values.
+*/
 template <typename T>
 inline T min(T a, T b)
@@ -89,4 +102,7 @@
 }
 
+/**
+    @brief Returns the greater of two values.
+*/
 template <typename T>
 inline T max(T a, T b)
@@ -95,4 +111,10 @@
 }
 
+/**
+    @brief Keeps a value between a lower and an upper limit.
+    @param x The value
+    @param min The lower limit
+    @param max The upper limit
+*/
 template <typename T>
 inline T clamp(T x, T min, T max)
@@ -107,4 +129,7 @@
 }
 
+/**
+    @brief Returns the square value (x^2).
+*/
 template <typename T>
 inline T square(T x)
@@ -113,4 +138,7 @@
 }
 
+/**
+    @brief Returns the cube value (x^3).
+*/
 template <typename T>
 inline T cube(T x)
@@ -119,4 +147,7 @@
 }
 
+/**
+    @brief Rounds the value down.
+*/
 template <typename T>
 inline int floor(T x)
@@ -125,4 +156,7 @@
 }
 
+/**
+    @brief Rounds the value up.
+*/
 template <typename T>
 inline int ceil(T x)
@@ -132,4 +166,7 @@
 }
 
+/**
+    @brief Rounds the value.
+*/
 template <typename T>
 inline int round(T x)
@@ -138,4 +175,9 @@
 }
 
+/**
+    @brief The modulo operation, enhanced to work properly with negative values.
+    @param x The value
+    @param max The operand
+*/
 template <typename T>
 inline int mod(T x, int max)
@@ -147,4 +189,11 @@
 }
 
+/**
+    @brief Interpolates between two values for a time between 0 and 1.
+    @param time The time is a value between 0 and 1 - the function returns start if time is 0 and end if time is 1 and interpolates if time is between 0 and 1.
+    @param start The value at time = 0
+    @param end The value at time = 1
+    @return The interpolation at a given time
+*/
 template <typename T>
 T interpolate(float time, const T& start, const T& end)
@@ -153,4 +202,11 @@
 }
 
+/**
+    @brief Interpolates smoothly between two values for a time between 0 and 1. The function starts slowly, increases faster and stops slowly again.
+    @param time The time is a value between 0 and 1 - the function returns start if time is 0 and end if time is 1 and interpolates if time is between 0 and 1.
+    @param start The value at time = 0
+    @param end The value at time = 1
+    @return The smoothed interpolation at a given time
+*/
 template <typename T>
 T interpolateSmooth(float time, const T& start, const T& end)
@@ -159,4 +215,7 @@
 }
 
+/**
+    @brief Returns a random number between 0 and 1.
+*/
 inline _UtilExport float rnd()
 {
@@ -164,4 +223,8 @@
 }
 
+/**
+    @brief Returns a random number between 0 and max.
+    @param max The maximum
+*/
 inline _UtilExport float rnd(float max)
 {
@@ -169,4 +232,9 @@
 }
 
+/**
+    @brief Returns a random number between min and max.
+    @param min The minimum
+    @param max The maximum
+*/
 inline _UtilExport float rnd(float min, float max)
 {
